using System;
using System.Collections.Generic;
using System.Text;

namespace DataSetTypes
{
    public interface IParameter<T>
    {
        T Upper { get;set;}
        T Lower { get;set;}
        string Name { get; set;}
    }

    public struct Parameter<T> : IParameter<T>
    {
        private T upper, lower;
        private string name;

        public Parameter(T upper, T lower) { this.lower = lower; this.upper = upper; name = ""; }
        public Parameter(T upper, T lower, string name) { this.lower = lower; this.upper = upper; this.name = name; }

        public T Upper { get { return upper; } set { upper = value; } }
        public T Lower { get { return lower; } set { lower = value; } }
        public string Name { get { return name; } set { name = value; } }
    }

}
