using System;
using System.Collections.Generic;
using System.Text;


namespace DataSetTypes
{
    public enum MarkerType { TRIGGER, EVENT }
    
    public struct Marker
    {
        private DateTime timeStamp;
        private MarkerType markerType;
        private string comment;

        public Marker(DateTime timeStamp, MarkerType type)
        { this.timeStamp = timeStamp; markerType = type; comment = ""; }
        public Marker(DateTime timeStamp, MarkerType type, string comment)
        { this.timeStamp = timeStamp; markerType = type; this.comment = comment; }
        public Marker(MarkerType type) { timeStamp = DateTime.Now; markerType = type; comment = ""; }

        public string Comment { get { return comment; } set { comment = value; } }
        public MarkerType MarkerType { get { return markerType; } }
        public Type Type { get { return typeof(ulong); } }
        public object Data { get { return timeStamp; } set { timeStamp = (DateTime)value; } }
        public DateTime TimeStamp { get { return TimeStamp; } set { timeStamp = value; } }
                
    }
}
