using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using XYZDataSetVisualizer;
using DataSetVisualizer;
using System.Windows.Forms;
using Motr3D;

namespace XYZDataSetVisualizer.GUI.Demo
{
    public partial class XYZDataSetVisualizerDemo : Form
    {
        protected XYZDataSetView mouseDataSet = new XYZDataSetView("Test");
        float[][] mousePosX, mousePosZ, mousePosY;
        Visualizer display;

        public XYZDataSetVisualizerDemo(IMotr3DImplementation renderingEngine)
        {
            InitializeComponent();
            display = new Visualizer(renderingEngine);
            mouseDataSet.DisplayType = DisplayType.SURFACE;
            mouseDataSet.SingleColor = Color.Red;
            mouseDataSet.DisplayStyle = DisplayStyle.WIREFRAME;
            display.Dock = DockStyle.Fill;
            display.AddSignal(mouseDataSet);
            this.Controls.Add(display);
            display.MouseMove += new MouseEventHandler(OnMouseMove);
        }

        //Does not work since the viewport consumes all events
        protected void OnMouseMove(object sender, MouseEventArgs e)
        {
            float calibPosX = ((float)e.X / (float)this.Width) * mousePosX.GetLength(0);
            float calibPosY = ((float)e.Y / (float)this.Height) * mousePosZ[0].Length;

            for (int i = 1; i < mousePosZ.GetLength(0)-1; i++)
            {
                for (int j = 1; j < mousePosX[0].Length-1; j++)
                {
                    float distance = (float)(Math.Sqrt(Math.Pow(i - calibPosX, 2) + Math.Pow(j - calibPosY, 2)));
                    float res = (20 / distance) * 10;
                    if(res>50){res=50;}
                    mousePosY[i][j] = res;
                }
            }

            mouseDataSet.DisplayData(mousePosX, mousePosY, mousePosZ);
            base.OnMouseHover(e);
        }

        public virtual void GenerateDataSet(int x, int y)
        {
            mousePosX = new float[x][]; mousePosZ = new float[x][]; mousePosY = new float[x][];
            for (int i = 0; i < x; i++) 
            { 
                mousePosX[i] = new float[y]; 
                mousePosY[i] = new float[y]; 
                mousePosZ[i] = new float[y]; }
            for (int i = 0; i < x; i++) 
            { 
                for (int j = 0; j < y; j++) 
                {
                    mousePosX[i][j] = (float)j;
                    mousePosY[i][j] = 0f;
                    mousePosZ[i][j] = (float)i;
                } 
            }
        }


        public static void Main()
        {
            //DataSetVisualizerDemo frm = new DataSetVisualizerDemo();
            //frm.GenerateDataSet(100, 50 );
            
            ///frm.Show();
            //Application.Run(frm);
            
       
        }
    }
}