using System;
using System.Collections.Generic;
using System.Text;
using Motr3D;
using Math32.LinearAlgebra;

namespace DataSetVisualizer
{
    public class ProportionalAxisGraduation: AxisGraduation
    {
        protected int divisions;
        
        public ProportionalAxisGraduation(Vertex start, Vertex end, Vertex normal, int divisions, float tickLength, bool showLabels)
            :base(start, end, normal, Vertex.Magnitude(end - start)/divisions, tickLength, showLabels)
        {
            this.divisions = divisions;
        }

        public virtual int Divisions
        {
            get { return divisions; }
            set { divisions = value; distance = Vertex.Magnitude(upperBound - lowerBound) / divisions; }
        }

        public override float Distance
        {
            get { return Vertex.Magnitude(upperBound - lowerBound) / divisions; }
            set
            {
                Divisions = (int)(Vertex.Magnitude(upperBound - lowerBound) / value);
                base.Distance = value;
            }
        }

        public override Vertex LowerBound
        {
            get { return base.LowerBound; }
            set
            {
                distance = Vertex.Magnitude(upperBound - value) / divisions;
                base.LowerBound = value;
            }
        }

        public override Vertex UpperBound
        {
            get { return base.UpperBound; }
            set
            {
                distance = Vertex.Magnitude(value - lowerBound) / divisions;
                base.UpperBound = value;
            }
        }
    }
}
