using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

namespace Elements
{
    public delegate void RessourceChangedHandler(IElement sender, string ressource);

    public interface IElement: IComponent, IDisposable
    {
        string ElementName { get; }
        List<IPort> Ports { get; }
        //IRessourceLocator DomainRessourceLocator { get; set; }
        List<RessourceHandler> RessourceHandlers { get;}

        event RessourceChangedHandler RessourceChanged;
        IPort ControlPort { get;}
        void OnRessourceChanged(string ressource);


        void HandleRessource(RessourceHandler resh, IMessage m);        
    }
}
