using System;
using System.Collections.Generic;
using System.Text;

namespace Elements
{
    public delegate void NewRessourceHandler(IResponse m, IPort sender);
    public interface IPort
    {
        string PortName { get; }
        URL URL { get;}
        URL[] AvailableRessources { get;}
        IElement Owner { get; }
        void Dispose();
        void Listen(IPort p, string listenedRessource, string targetRessource);
        void Quiet(IPort p, string listenedRessource, string targetRessource);
        void AdvertiseRessource(string ressource, params object[] data);
        void HandleRequest(IRequest r);
        void SendRequest(IRequest r);
        void HandleResponse(IResponse r);
        List<IResponse> Listeners { get;}
        void SendResponse(IResponse r);
        void SendResponse(IRequest request, object[] data, bool sucess);
        void Connect(IPort p);
        void Disconnect(IPort p);
        void SendRequestToAll(string sendingRessource, string targetRessource, object[] args, Verb verb);
        void AddRessourceHandlers(params RessourceHandler[] ressourceHandlers);
        void RemoveRessourceHandler(RessourceHandler resh);
    }
}
