using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using Elements;

namespace SignalProcessing.GUI
{
    public partial class SignalProcessorGUI : UserControl
    {
        private SignalProcessor owner;

        private SignalProcessorGUI() { InitializeComponent(); }
        public SignalProcessorGUI(SignalProcessor owner)
        {
            Owner = owner;
            InitializeComponent();
        }

        public SignalProcessor Owner
        {
            get { return owner; }
            set 
            {
                if (owner != null)
                {
                    owner.RessourceChanged -= new RessourceChangedHandler(OwnerRessourceChanged);
                }
                owner = value;
                if (value != null)
                {
                    owner.RessourceChanged += new RessourceChangedHandler(OwnerRessourceChanged);
                }
            }
        }

        protected virtual void OwnerRessourceChanged(IElement sender, string ressource) { }
    }
}
