using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using Motr3D.Primitives;
using System.Windows.Forms;
using Math32.LinearAlgebra;

namespace Motr3D
{
    public interface IMotr3DImplementation: IDisposable
    {
        //event EventHandler DeviceReset;
        //event EventHandler DeviceReady;

        Control ViewPort { get; }
        FillMode CurrentFillMode { get; set; }
        CullMode CurrentCullMode { get; set; }
        Lighting EnableLighting { get; set; }
        //bool RenderInScreenSpace { get; set;}
        int RenderHeight { get; set;}
        int RenderWidth { get; set;}
        bool DepthBuffer { get; set;}

        void SetPerspectiveProjection(float fieldOfView, float aspectRatio, float nearClipDistance, float farClipDistance);
        void SetOrthogonalProjection(float width, float height, float nearClipDistance, float farClipDistance);
        void TransformCamera(Matrix44 transform);
        void TransformWorld(Math32.LinearAlgebra.Matrix44 transform);
        void InitializeImplementation(Control viewport);
        void ResetRenderingEngine();
        void BeginRendering();
        void EndRendering();
        void Target(Camera camera);
        void DisplayRender();
        void DrawObject(Object3D obj);
        //void DisplayScreenSpaceRender();
        void ClearTarget(Color color);
        Bitmap GetLastRender();
    }
}
