using System;
using System.Collections.Generic;
using System.Text;
using Motr3D.Primitives;

namespace Motr3D
{
    public interface IObject3DImplementation: IDisposable
    {
        Object3D Object3D { get;}
        bool Disposed { get;}
        
        void DrawSelf();
        void Update();
        void Optimize();
    }
    public interface IMeshImplementation : IObject3DImplementation
    {
        Mesh Mesh { get;}
        bool Intersect(Mesh m);
    }
    public interface ICameraImplementation : IObject3DImplementation
    {
        void Target();
    }
}
