using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using Math32.LinearAlgebra;

namespace Motr3D
{
    public enum LightType { Directional = 3, Point = 2, Spot = 1 }
    public enum EmittedLight { Diffuse = 2, Specular = 1 }

    public abstract class Light : Object3D
    {
        protected Color ambientColor = Color.White, diffuseColor = Color.White;
        protected LightType lightType = LightType.Directional;
        protected EmittedLight emittedLight = EmittedLight.Diffuse;
        protected float range = float.MaxValue;
        protected int nbCamera = 0;
        protected Vertex direction;

    }

    /*public class DirectionnalLight: Light { }
    public class SpotLight : DirectionnalLight { }
    public class PointLight : Light { }*/
}
