using System;
using System.Collections.Generic;
using System.Text;

namespace Motr3D
{
    public abstract class Object3DImplementation :IObject3DImplementation
    {
        private Object3D object3D;
        private bool disposed = false;

        public Object3DImplementation(Object3D object3D) 
        {
            this.object3D = object3D; 
        }

        public Object3D Object3D { get { return object3D; } }
        public bool Disposed { get { return disposed; } }

        public void Dispose() { Dispose(true); }
        protected void Dispose(bool managedRessources)
        {
            if (!disposed)
            {
                if (managedRessources)
                {
                    DisposeImplementation();
                    GC.SuppressFinalize(this);
                }
            }
            disposed = true;
        }
        protected abstract void DisposeImplementation();

        public abstract void DrawSelf();
        public abstract void Update();
        public abstract void Optimize();

        public override string ToString() { return object3D.ToString() + " Implementation"; }
    }
}
