using System;
using System.Collections.Generic;
using System.Text;
using Math32.LinearAlgebra;

namespace Motr3D.Primitives
{
    public class Cube: Mesh
    {
        protected float x, y, z;

        public Cube(float x, float y, float z)
        {
            this.x = x; this.y = y; this.z = z;
            GenerateVertexData();
        }

        public float X { get { return x; } set { x = value; GenerateVertexData(); } }
        public float Y { get { return y; } set { y = value; GenerateVertexData(); } }
        public float Z { get { return z; } set { z = value; GenerateVertexData(); } }

        protected override void GenerateVertexData()
        {
            Vertices = new Vertex[8] 
            { 
                new Vertex(0,0,0,Color),
                new Vertex(x,0,0,Color),
                new Vertex(x,0,z,Color),
                new Vertex(0,0,z,Color),
                new Vertex(0,y,0,Color), 
                new Vertex(x,y,0,Color),
                new Vertex(x,y,z,Color),
                new Vertex(0,y,z,Color)
            };

            Indices = new short[36]
            {
                0,1,2,0,2,3, //XZ bottom
                0,5,1,0,5,4, //XY front
                0,4,7,0,7,4, //YZ left
                3,6,7,3,2,6, //XY back
                4,7,6,4,6,5, //XZ top
                1,5,2,5,6,2  //YZ right
            };
        }
    }
}
