using System;
using System.Collections.Generic;
using System.Text;
using Math32.LinearAlgebra;

namespace Motr3D.Primitives
{
    public class PointList : VertexPrimitive
    {
        protected int numberOfPoints;
        protected float[] x, y, z;
        
        public PointList():base()
        { 
            name = "Point List";
            numberOfPoints = 1;
            x = new float[1] { 0 }; y = new float[1] { 0 }; z = new float[1] { 1 };
            GenerateVertexData();        
        }
        public PointList(int numberOfPoints):base()
        {
            name = "Point List";
            this.numberOfPoints = numberOfPoints;
            x = new float[1] { 0 }; y = new float[1] { 0 }; z = new float[1] { 1 };
            GenerateVertexData();
        }

        public virtual void GeneratePointList(float[] x, float[] y, float[] z)
        {
            this.x = x; this.y = y; this.z = z;
            GenerateVertexData();
        }

        protected override void GenerateVertexData()
        { 
            Vertex[] vertices = new Vertex[x.Length];
            for (int i = 0; i < x.Length; i++)
            { 
                vertices[i].color = Color.ToArgb();
                vertices[i].x = x[i];
                vertices[i].y = y[i];
                vertices[i].z = z[i];
            }
            Vertices = vertices;
        }
    }
}
